---
title: IntersectionObserver.rootMargin
slug: Web/API/IntersectionObserver/rootMargin
tags:
  - API
  - Intersection Observer
  - Intersection Observer API
  - IntersectionObserver
  - Property
  - Reference
  - rootMargin
---
<div>{{APIRef("Intersection Observer API")}}{{SeeCompatTable}}</div>

<p>The {{domxref("IntersectionObserver")}} interface's read-only <strong><code>rootMargin</code></strong> property is a string with syntax similar to that of the CSS {{cssxref("margin")}} property. Each side of the rectangle represented by <code>rootMargin</code> is added to the corresponding side in the {{domxref("IntersectionObserver.root", "root")}} element's {{Glossary("bounding box")}} before the intersection test is performed. This lets you, for example, adjust the bounds outward so that the target element is considered 100% visible even if a certain number of pixels worth of width or height is clipped away, or treat the target as partially hidden if an edge is too close to the edge of the root's bounding box.</p>

<p>See {{SectionOnPage("/en-US/docs/Web/API/Intersection_Observer_API", "The root element and root margin")}} for a more in-depth look at the root margin and how it works with the root's bounding box.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox"><var><code>var <em>marginString</em> = </code>IntersectionObserver</var>.rootMargin;
</pre>

<h3 id="Value">Value</h3>

<p>A string, formatted similarly to the CSS {{cssxref("margin")}} property's value, which contains offsets for one or more sides of the root's bounding box. These offsets are added to the corresponding values in the root's bounding box before the intersection between the resulting rectangle and the target element's bounds.</p>

<p>The string returned by this property may not match the one specified when the {{domxref("IntersectionObserver")}} was instantiated. The browser is permitted to alter the values</p>

<p>If <code>rootMargin</code> isn't specified when the object was instantiated, it defaults to the string <code>"0px 0px 0px 0px"</code>, meaning that the intersection will be computed between the root element's unmodified bounds rectangle and the target's bounds.  {{SectionOnPage("/en-US/docs/Web/API/Intersection_Observer_API", "The root element and root margin")}} describes how the <code>rootMargin</code> is used in more detail.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('IntersectionObserver', '#dom-intersectionobserverinit-rootmargin', 'IntersectionObserver.rootMargin')}}</td>
   <td>{{Spec2('IntersectionObserver')}}</td>
   <td>Initial definition</td>
  </tr>
 </tbody>
</table>

<div>
<h2 id="Browser_compatibility">Browser compatibility</h2>

<p class="hidden">The compatibility table in this page is generated from structured data. If you'd like to contribute to the data, please check out <a href="https://github.com/mdn/browser-compat-data">https://github.com/mdn/browser-compat-data</a> and send us a pull request.</p>

<p>{{Compat("api.IntersectionObserver.rootMargin")}}</p>
</div>
